"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OriginInterceptor = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
const sdk_nestjs_common_1 = require("@multiversx/sdk-nestjs-common");
let OriginInterceptor = class OriginInterceptor {
    intercept(context, next) {
        const contextType = context.getType();
        if (!["http", "https"].includes(contextType)) {
            return next.handle();
        }
        const apiFunction = context.getClass().name + '.' + context.getHandler().name;
        sdk_nestjs_common_1.ContextTracker.assign({ origin: apiFunction });
        return next
            .handle()
            .pipe((0, operators_1.tap)(() => sdk_nestjs_common_1.ContextTracker.unassign()), (0, operators_1.catchError)(err => {
            sdk_nestjs_common_1.ContextTracker.unassign();
            return (0, rxjs_1.throwError)(() => err);
        }));
    }
};
OriginInterceptor = tslib_1.__decorate([
    (0, common_1.Injectable)()
], OriginInterceptor);
exports.OriginInterceptor = OriginInterceptor;
//# sourceMappingURL=origin.interceptor.js.map